/*
** Delete a record from a look up table
** Class: DeleteRow
** Author: Yuping Zhu
** Date: 04-09-1999
** Modified: 08-10-1999
**           Add Delete Warning
*/

package ascdb.admin;

// import package oracle.html.* to generate dynamic HTML page
import oracle.html.*;

// import package java.sql to use JDBC
import java.sql.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.conf;
import ascdb.pub.UserCheck;
import java.text.Collator;

public class DeleteRow extends HttpServlet {

     public static String me = null;
     public static String Id = null;
	

     public void doGet(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
	// Output HTML page header
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();
	conf dbconf = new conf(req);
	me = req.getParameter("me");
	UserCheck u = new UserCheck(me);
	String TableName = req.getParameter("name");
	Id = req.getParameter("id");
	int op = (new Integer(req.getParameter("op"))).intValue();

	try {
	   if (u.UserRole(1) != 0)
	   {
		out.println(u.userid + "! You do not have this privilege!");
		return;
	   }
	   // Load the Oracle JDBC driver
	   Class.forName (dbconf.JdbcDriver);
	
	   // Connect to the database
 	   Connection conn =
    		DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);

	   // Create a Statement
	   Statement stmt = conn.createStatement ();

	   Collator cl = Collator.getInstance();
	   String ColumnName = " surtitle ";
	   if (cl.equals(TableName,"v_states"))
		ColumnName = " state ";
	   else if (cl.equals(TableName,"v_countries"))
		ColumnName = " country_abbr ";
           
	   ResultSet rset = stmt.executeQuery("select * from " + TableName + " where " + ColumnName + "='" + Id + "'");

	   String Value1 = null;
	   if (rset.next()) 
	   	 Value1 = rset.getString(1);
	   String Value2 = null;
	   if (! cl.equals(TableName,"v_surtitles"))
		Value2 = rset.getString(2);
	
	   String UpdateString = null;
	   if (op == 1)
	      out.print(DeleteWarning(TableName, Value1, Value2));
           else 
	      if (op == 2) {
		   UpdateString = "delete from " + TableName + " where " + ColumnName + "='" + Id + "'";
		   int rcount = stmt.executeUpdate(UpdateString);
	
		   if (rcount == 1)
			out.println(Id + " has been deleted!");
	   	   else
			out.println(UpdateString);
	      }
	      else if (op == 3)
		   out.println(Id + " is not deleted!");	
	   }
	   catch(ClassNotFoundException e) {
                 out.println("Couldn't load database driver: " + e.getMessage());
           }
           catch (SQLException e) { 
                out.println(e.getMessage());
           }
	   catch(Exception e) {
		out.println(e.getMessage());
	   }
   }
   
   public static HtmlPage DeleteWarning(String TN, String V1, String V2) {
	// Creates an HtmlHead Object
           HtmlHead hd = new HtmlHead("Delete Warning");
        
        // Create an HtmlBody Object
           HtmlBody bd = new HtmlBody();

        // Sets various attributes of HtmlBody
           bd.setBackgroundColor("#fffff2");
             
        // Creates an HtmlPage object using hd and bd
           HtmlPage hp = new HtmlPage(hd, bd);
	
	Collator cl1 = Collator.getInstance();
	String Tit;

	if (cl1.equals(TN,"v_surtitles")) 
	    Tit = "Surtitle " + V1 + " will be deleted from table '" + TN +"'";
	else
	   if (cl1.equals(TN,"v_states")) 
	    Tit = "State " +V1+ " (" + V2 + ") will be deleted from table '" + TN +"'";
	else
	    Tit = "Country " +V1+ " (" + V2 + ") will be deleted from table '" + TN +"'";
	Form frm1 = new Form("GET","ascdb.admin.DeleteRow");
	frm1
	   .addItem(SimpleItem.LineBreak)
	   .addItem(new Hidden("me",me))
	   .addItem(new Hidden("id",Id))
	   .addItem(new Hidden("name",TN))
	   .addItem(new Hidden("op","2"))
	   .addItem(new Submit("submit","Delete!"));
	
	Form frm2 = new Form("GET","ascdb.admin.DeleteRow");
	frm2
	   .addItem(new Hidden("me",me))
	   .addItem(new Hidden("op","3"))
 	   .addItem(new Hidden("name",TN))
	   .addItem(new Hidden("id",Id))
	   .addItem(new Submit("submit","No!"));

	bd
	  .addItem(new SimpleItem(Tit + "...!").setBold().setFontColor(Color.red))
	  .addItem(frm1.setCenter().setBold())
	  .addItem(frm2.setCenter().setBold());
        
  	return(hp);
    }	
}       